// ACTUAL ARENA MODE
//      Serversent plugin by Cerapter

// Let's make a new object that's gonna mark everybody for everybody
global.marker = object_add();
with (global.marker) {depth=-11000};
object_event_add(global.marker,ev_draw,0,"
if ArenaHUD.cpUnlock <= 0 
{
var xOffset,yOffset,width,height;

xOffset = view_xview[0];
yOffset = view_yview[0];
width = view_wview[0];
height = view_hview[0];

with(Character) {
    var theta, unknown, cornerDegree, viewCentreX, viewCentreY;
    cornerDegree = arcsin(.6);
	if team==TEAM_RED {
		draw_set_color(c_red);
	} else {
		draw_set_color(c_blue);
	}
    if(     
            (x > xOffset + width || x < xOffset || y > yOffset+height || y < yOffset)) {
        draw_set_alpha(1);
		
		if global.myself.object != -1 
		{
			viewCentreX = global.myself.object.x;
			viewCentreY = global.myself.object.y;
		}
		else
		{
			viewCentreX = view_xview+view_wview/2;
			viewCentreY = view_yview+view_hview/2;
		}
		
        theta = point_direction(viewCentreX, viewCentreY, x, y)*pi/180;
        if(theta <= cornerDegree || theta > 2*pi - cornerDegree){
            unknown = (width/2 - 38*cos(theta))*tan(theta);
            draw_sprite_ext(MedRadarArrow, floor(hp/maxHp * 19), xOffset + width - cos(theta)*38, yOffset+ height/2 -unknown, 1,1,theta*180/pi, c_white, 1);

                draw_sprite_ext(MedAlert, (player.team * 10) + player.class + 2, xOffset + width - cos(theta)*38, yOffset+ height/2 -unknown, 1, 1, 0, c_white, 1);
                draw_set_halign(fa_right);
                if(theta< pi) {
                    draw_text(xOffset + width, yOffset+ height/2 -unknown + 20, player.name);
                } else {
                    draw_text(xOffset + width, yOffset+ height/2 -unknown - 20, player.name);
                }
            
        } else if(theta > cornerDegree && theta <= pi - cornerDegree){
            unknown = (height/2 - 38*sin(theta))*(1/tan(theta));
            draw_sprite_ext(MedRadarArrow, floor(hp/maxHp * 19), xOffset + unknown+width/2, yOffset+38*sin(theta), 1,1,theta*180/pi, c_white, 1);
                draw_sprite_ext(MedAlert, (player.team * 10) + player.class + 2, xOffset + unknown+width/2, yOffset+38*sin(theta), 1,1,0, c_white, 1);
                draw_text(xOffset + unknown+width/2, yOffset+38*sin(theta) + 20, player.name);
        } else if(theta > pi - cornerDegree && theta <= pi + cornerDegree){
            unknown = (width/2 +38*cos(theta))*tan(theta);
            draw_sprite_ext(MedRadarArrow, floor(hp/maxHp * 19), xOffset -38*cos(theta), yOffset + unknown +height/2, 1,1,theta*180/pi, c_white, 1);
                draw_sprite_ext(MedAlert, (player.team * 10) + player.class + 2, xOffset - 38*cos(theta), yOffset + unknown +height/2, 1,1,0, c_white, 1);
                draw_set_halign(fa_left);
                if(theta < pi) {
                    draw_text(xOffset, yOffset + unknown +height/2 +20, player.name);
                } else {
                    draw_text(xOffset, yOffset + unknown +height/2 -20, player.name);
                }
        } else {
            unknown = (height/2+ 38*sin(theta))*(1/tan(theta));
            draw_sprite_ext(MedRadarArrow, floor(hp/maxHp * 19), xOffset +width/2 - unknown, yOffset + height+38*sin(theta), 1,1,theta*180/pi, c_white, 1);
                draw_sprite_ext(MedAlert, (player.team * 10) + player.class + 2, xOffset +width/2 - unknown, yOffset + height+38*sin(theta), 1,1,0, c_white, 1);
                draw_text(xOffset +width/2 - unknown, yOffset + height+38*sin(theta) - 20, player.name);
        }
    }
}

draw_set_alpha(1);
}
");

// Setting the new time (double the old) and circumventing some old mechanisms
// Hopefully, with success
// Also, I don't like replacing entire events, but I can't see any other way
object_event_add(ArenaHUD,ev_create,0,"instance_create(0,0,global.marker); cpUnlock = 3600;");
object_event_clear(ArenaHUD,ev_step,ev_step_normal);
object_event_add(ArenaHUD,ev_step,ev_step_normal,"
// Normally, the game would reset the timer to 1800
// We're gonna circumvent that
// It would cut some time, that's why we set it to 3602
if cpUnlock == 1800 then cpUnlock = 3602;
if cpUnlock == 1801 then cpUnlock = 1799;

//start game if there are 2 or more players and
//check for last player on a team then restart arena

redteam = 0;
blueteam = 0;
redteamCharacters = 0;
blueteamCharacters = 0;

for(i=0; i<ds_list_size(global.players); i+=1) {
    player = ds_list_find_value(global.players, i);
    if(player.team == TEAM_RED) {
        redteam+=1;
        if player.object != -1 || alarm[5] != -1 redteamCharacters+=1;
    } else if (player.team == TEAM_BLUE) {
        blueteam+=1;
        if player.object != -1 || alarm[5] != -1 blueteamCharacters+=1;    
    }
}

if global.isHost {
	if cpUnlock == 1801 {
	GameServer.syncTimer = 1;
	}
    if ArenaControlPoint.team != -1 winners = ArenaControlPoint.team;
    if (blueteamCharacters == 0 || redteamCharacters == 0) && roundStart == 0{
        if (redteam >= 1 || blueteam >=1) && winners == TEAM_SPECTATOR {
            if blueteamCharacters == 0 && gameStarted == 1 {
                winners = TEAM_RED;
            }
            else if redteamCharacters == 0 && gameStarted == 1 {
                winners = TEAM_BLUE;
            }
            else {
                winners = TEAM_SPECTATOR;
                if redteam >= 1 && blueteam >=1 && gameStarted == 0 {
                    serverArenaRestart();
                    gameStarted = 1;
                }
            }
        }
    }
    if winners != TEAM_SPECTATOR {
        endCount += 1;
        if endCount == 300 && overtime == 0 && timer != 0{
            endCount = 0;
            if redteam == 0 || blueteam == 0 {
                gameStarted = 0;
                winners = TEAM_SPECTATOR;
                with Player {
                    if object != -1 {
                        if id = global.myself && !instance_exists(Spectator) {
                            instance_create(object.x,object.y,Spectator);
                            with object instance_destroy();
                        }
                    }
                }
                with Sentry instance_destroy();
                with SentryGibs instance_destroy();
            }
            else serverArenaRestart();
        }
        else if endCount == 1 {
            serverArenaEndRound();
        }
    }
}
//else if client, increase endcount once server sends the EndRound message
else {
    if endCount >0 endCount +=1;
    if endCount == 300 endCount = 0;
    //also check number of red/blue players to set winners as spec
    if winners != TEAM_SPECTATOR 
    && endCount == 0 && (redteam == 0 || blueteam == 0) {
        winners = TEAM_SPECTATOR;
    }
    
}

if cpUnlock <= 0 
	{
		//It is now pointless to keep the MedicRadar around, hide it
		with (MedicRadar) {visible = 0};
	}
	else if cpUnlock == 0  {
        with(NoticeO) instance_destroy();
		notice = instance_create(0,0,NoticeO);
		notice.notice = NOTICE_CUSTOM;
		notice.message = 'Players are now marked!';
    }
    else if cpUnlock == 150 {
        with(NoticeO) instance_destroy();
		notice = instance_create(0,0,NoticeO);
		notice.notice = NOTICE_CUSTOM;
		notice.message = 'Players will be marked in 5 seconds!';
    }
	else if cpUnlock == 1799 {
        with(NoticeO) instance_destroy();
		notice = instance_create(0,0,NoticeO);
		notice.notice = NOTICE_CUSTOM;
		notice.message = 'The control point will not unlock, but players will be marked in 60 seconds!';
}

if roundStart == 0 cpUnlock = max(cpUnlock-1,-1);

//when roundStart reaches 0 players can no longer change team/class
//and respawn
else if roundStart >0 roundStart -=1;
if (roundStart == 1)
{
    if (global.isHost)
    {
        sendEventArenaStartRound();
        doEventArenaStartRound();
        GameServer.syncTimer = 1;
    }
}
    
//timer
if timer > 0 timer -=1;

if timer == 0{
    if redteamCharacters >0 && blueteamCharacters >0 && redteam >0 && blueteam >0 && winners == TEAM_SPECTATOR { 
        overtime = 1;
    }
    else if endCount == 300 || gameStarted == 0 {
        global.winners = TEAM_SPECTATOR;
    }
}
");

// Now we're gonna replace the Draw event for no reason other than aesthetics
// I can't spell aesthetics
object_event_clear(ArenaHUD,ev_draw,0);
object_event_add(ArenaHUD,ev_draw,0,'
var xoffset, yoffset, xsize, ysize, xshift, yshift;
xoffset = view_xview[0];
yoffset = view_yview[0];
xsize = view_wview[0];
ysize = view_hview[0];
xshift = -320*global.timerPos;
yshift = 5*global.timerPos;

if instance_exists(WinBanner) with WinBanner instance_destroy();

draw_set_color(c_white);
draw_set_valign(fa_center);
draw_set_alpha(1);
        
// CP -- NOT! We are going to draw text here!
// Background rectangle
draw_set_halign(fa_center);
draw_set_color(c_black);
draw_set_alpha(0.6);
stringWidth = string_width("Cannot cap control point!");
stringHeight = string_height("Cannot cap control point!");
draw_rectangle(xoffset+xsize/2+13-(stringWidth/3*2),yoffset+563-(stringHeight/4*3),xoffset+xsize/2+13+(stringWidth/3*2),yoffset+563+(stringHeight/4*3),0);
// Background rectangle that is also a timer
draw_set_color(c_purple);
draw_set_alpha(0.3);
stringWidth = string_width("Cannot cap control point!");
stringHeight = string_height("Cannot cap control point!");
draw_rectangle(xoffset+xsize/2+13-((stringWidth/3*2)/3600*cpUnlock),yoffset+563-(stringHeight/4*3),xoffset+xsize/2+13+((stringWidth/3*2)/3600*cpUnlock),yoffset+563+(stringHeight/4*3),0);
// Text
draw_set_color(c_white);
draw_set_alpha(1);
draw_text(xoffset+xsize/2+13,yoffset+563,"Cannot cap control point!");

//timer
draw_set_color(c_white);
if global.myself != -1 {
    if global.myself.team == TEAM_RED teamoffset=0;
    else if global.myself.team == TEAM_BLUE teamoffset=1;
}
if overtime == 1 {
    draw_set_halign(fa_center);
    draw_sprite_ext(TimerHudS,2+teamoffset,xoffset+xsize/2+xshift,yoffset+30+ yshift,3,3,0,c_white,1);
    draw_text(xoffset+xsize/2+xshift,yoffset+30+ yshift,"OVERTIME");
}
else{
    draw_set_halign(fa_right);
    draw_sprite_ext(TimerHudS,teamoffset,xoffset+xsize/2 +xshift,yoffset+30+ yshift,3,3,0,c_white,1);
    draw_sprite_ext(TimerS,floor(timer/timeLimit*12),xoffset+xsize/2+39 +xshift,yoffset+30+ yshift,3,3,0,c_white,1);
    minutes=floor(timer/1800);
    secondcounter=timer-minutes*1800;
    seconds=floor(secondcounter/30);    
    draw_text_transformed((xoffset+xsize/2-1)-10+xshift,yoffset+32+ yshift,string(minutes),1.5,1.5,0);
    draw_text_transformed((xoffset+xsize/2)+xshift,yoffset+32+ yshift,":",1.5,1.5,0);
    if seconds >= 10 draw_text_transformed((xoffset+xsize/2+20)+xshift,yoffset+32+ yshift,string(seconds),1.5,1.5,0);
    else if seconds < 10 draw_text_transformed((xoffset+xsize/2+20)+xshift,yoffset+32+ yshift,"0"+string(seconds),1.5,1.5,0);
}

draw_set_halign(fa_center); 
if roundStart > 0 {
    draw_text(xoffset+xsize/2,yoffset+ysize/2,"Game will start in "+string(floor(roundStart/30))+" seconds")
}

if global.myself != -1 {
    if global.myself.object == -1 && roundStart == 0 && winners == TEAM_SPECTATOR && global.winners == -1 && endCount == 0 && !instance_exists(DeathCam) && global.myself.team !=TEAM_SPECTATOR{
        draw_text(xoffset+xsize/2,yoffset+ysize/2,"You can spawn when the next round starts")
    }
    //Alive players remaining 
    draw_set_color(c_black);
    draw_sprite_ext(ArenaPlayerCountS,0,xoffset+xsize/2,yoffset+71,2,2,0,c_white,1);
    draw_text(xoffset+xsize/2+15,yoffset+73,redteamCharacters);
    draw_sprite_ext(ArenaPlayerCountS,1,xoffset+xsize/2,yoffset+104,2,2,0,c_white,1);
    draw_text(xoffset+xsize/2+15,yoffset+106,blueteamCharacters);
}
 
//MVPs
if endCount > 0 && global.winners == -1 && !instance_exists(ScoreTableController){
    if instance_exists(DeathCam) {
        with DeathCam instance_destroy();
    }
    
    draw_set_alpha(1);    
    draw_set_halign(fa_left);
    draw_set_color(c_white);

    offset = 15;
    if winners == TEAM_RED {
        if endCount < 150 {
            draw_sprite_ext(MVPBannerS,0,xoffset+xsize/2,yoffset+ysize/2,2,2,0,c_white,0.8);
            for (i=0; i<redMVPs; i+=1) {
                draw_text(xoffset+xsize/2-250,yoffset+ysize/2+76+offset*i,redMVPName[i]);
                draw_text(xoffset+xsize/2-30,yoffset+ysize/2+76+offset*i,redMVPKills[i]);
                draw_text(xoffset+xsize/2+122,yoffset+ysize/2+76+offset*i,redMVPHealed[i]);
                draw_text(xoffset+xsize/2+248,yoffset+ysize/2+76+offset*i,redMVPPoints[i]);
            }
        }
        else if endCount >= 150 {
            draw_sprite_ext(MVPBannerS,1,xoffset+xsize/2,yoffset+ysize/2,2,2,0,c_white,0.8);
            for (i=0; i<blueMVPs; i+=1) {
                draw_text(xoffset+xsize/2-250,yoffset+ysize/2+76+offset*i,blueMVPName[i]);
                draw_text(xoffset+xsize/2-30,yoffset+ysize/2+76+offset*i,blueMVPKills[i]);
                draw_text(xoffset+xsize/2+122,yoffset+ysize/2+76+offset*i,blueMVPHealed[i]);
                draw_text(xoffset+xsize/2+248,yoffset+ysize/2+76+offset*i,blueMVPPoints[i]);
            }
        }
    }
    else if winners == TEAM_BLUE {
        if endCount < 150 {
            draw_sprite_ext(MVPBannerS,2,xoffset+xsize/2,yoffset+ysize/2,2,2,0,c_white,0.8);
            for (i=0; i<blueMVPs; i+=1) {
                draw_text(xoffset+xsize/2-250,yoffset+ysize/2+76+offset*i,blueMVPName[i]);
                draw_text(xoffset+xsize/2-30,yoffset+ysize/2+76+offset*i,blueMVPKills[i]);
                draw_text(xoffset+xsize/2+122,yoffset+ysize/2+76+offset*i,blueMVPHealed[i]);
                draw_text(xoffset+xsize/2+248,yoffset+ysize/2+76+offset*i,blueMVPPoints[i]);
            }
        }
        else if endCount >= 150 {
            draw_sprite_ext(MVPBannerS,3,xoffset+xsize/2,yoffset+ysize/2,2,2,0,c_white,0.8);
            for (i=0; i<redMVPs; i+=1) {
                draw_text(xoffset+xsize/2-250,yoffset+ysize/2+76+offset*i,redMVPName[i]);
                draw_text(xoffset+xsize/2-30,yoffset+ysize/2+76+offset*i,redMVPKills[i]);
                draw_text(xoffset+xsize/2+122,yoffset+ysize/2+76+offset*i,redMVPHealed[i]);
                draw_text(xoffset+xsize/2+248,yoffset+ysize/2+76+offset*i,redMVPPoints[i]);
            }
        }
    }
    draw_set_color(make_color_rgb(227,226,225));
    draw_set_halign(fa_right);
    draw_text_transformed(xoffset+384,yoffset+210,redWins,3.5,3.5,0);
    draw_set_halign(fa_left);
    draw_text_transformed(xoffset+415,yoffset+210,blueWins,3.5,3.5,0);

}
');
 